#ifndef OATH_FIFOQUEUE_H

#define OATH_FIFOQUEUE_H

//***************************************************************************
//             OATH :: Object-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991, 1990  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  fifoQueue (fifoQueueA, fifoQueueG)
//
//  History:
//    06/91  Brian M Kennedy  New macros & format; remove printDiagnostic
//    10/90  Brian M Kennedy  Major Rewrite
//    02/90  Brian M Kennedy  Original
//
//***************************************************************************

#include "seq.h"

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Class Definitions

/////////////////////////////////////////////////////////////////////////////
// class fifoQueueA

CLASS_A(fifoQueue, seq)


#define fifoQueue_RETURNING_DEFINITIONS(type)			    	    \
	seq_RETURNING_DEFINITIONS(type)					    \


	fifoQueue_RETURNING_DEFINITIONS(fifoQueue)

   };


/////////////////////////////////////////////////////////////////////////////
// class fifoQueueG

CLASS_G(fifoQueue, seq)

	// Constructors //////////

	    inline
        fifoQueueG (int IsConst = FALSE);

    public:
        // fifoQueue Operations //////////

   };


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Inline Definitions

/////////////////////////////////////////////////////////////////////////////
// fifoQueueG Inlines

// Constructors //////////

    inline fifoQueueG::
fifoQueueG (int IsConst) // IsConst = FALSE)
   :seqG(IsConst)
   {}


/////////////////////////////////////////////////////////////////////////////
// fifoQueueA Inlines

INLINES(fifoQueue, seq)


#define fifoQueue_RETURNING_INLINES(type)				    \
seq_RETURNING_INLINES(type)						    \


fifoQueue_RETURNING_INLINES(fifoQueue)


//***************************************************************************

#endif /* OATH_FIFOQUEUE_H */
