#ifndef OATH_FINITESET_H

#define OATH_FINITESET_H

//***************************************************************************
//             OATH :: Object-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  finiteSet (finiteSetA, finiteSetG)
//
//  History:
//    06/91  Brian M Kennedy  New macros & format; remove printDiagnostic
//    04/91  Brian M Kennedy  Original
//
//***************************************************************************

#include "set.h"

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Class Definitions

/////////////////////////////////////////////////////////////////////////////
// class finiteSetA

CLASS_A(finiteSet, set)


#define finiteSet_RETURNING_DEFINITIONS(type)  		    	    	    \
	set_RETURNING_DEFINITIONS(type)					    \
									    \
            inline const CAT(type,A)&					    \
        invert () const;						    \
									    \
	    inline CAT(type,A)						    \
	operator ~ () const;						    \


	finiteSet_RETURNING_DEFINITIONS(finiteSet)

   };


/////////////////////////////////////////////////////////////////////////////
// class finiteSetG

CLASS_G(finiteSet, set)

	// Constructors //////////

	    inline
        finiteSetG (int IsConst = FALSE);

    public:
        // finiteSet Operations //////////

	    virtual void
	invert ()
	    = 0;

   };


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Inline Definitions

/////////////////////////////////////////////////////////////////////////////
// finiteSetG Inlines

// Constructors //////////

    inline finiteSetG::
finiteSetG (int IsConst) // IsConst = FALSE
   :setG(IsConst)
   {}


/////////////////////////////////////////////////////////////////////////////
// finiteSetA Inlines

INLINES(finiteSet, set)

#define finiteSet_RETURNING_INLINES(type)	    		    	    \
set_RETURNING_INLINES(type)						    \
									    \
    inline const CAT(type,A)& CAT(type,A)::				    \
invert () const								    \
   {am().guts()->invert();						    \
    return *this;							    \
   }									    \
									    \
    inline CAT(type,A) CAT(type,A)::					    \
operator ~ () const							    \
   {return makeCopy().invert();}					    \


finiteSet_RETURNING_INLINES(finiteSet)


//***************************************************************************

#endif /* OATH_FINITESET_H */
