#ifndef OATH_GCCONFIG_H

#define OATH_GCCONFIG_H

//***************************************************************************
//             OATH :: Object-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991, 1990  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  Configuration options for OATH garbage collection
//
//  History:
//    06/91  Brian M Kennedy  Separate out options
//    10/90  Brian M Kennedy  Major Rewrite
//    02/90  Brian M Kennedy  Original
//
//***************************************************************************

/////////////////////////////////////////////////////////////////////////////
// Garbage Collection Mode

#define OATH_GC_OFF 0    // Turn off all garbage collection
#define OATH_GC_INC 1    // Collect incrementally (circular refs will be lost)
#define OATH_GC_SAC 2    // Stop & Collect (requires one extra word/obj)
#define OATH_GC_COM 3    // Incremental AND Stop & Collect (two extra words/obj)

#define OATH_GC OATH_GC_INC

//***************************************************************************

#endif /* OATH_GCCONFIG_H */
