#ifndef OATH_LIFOQUEUE_H

#define OATH_LIFOQUEUE_H

//***************************************************************************
//             OATH :: Object-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991, 1990  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  lifoQueue (lifoQueueA, lifoQueueG)
//
//  History:
//    06/91  Brian M Kennedy  New macros & format; remove printDiagnostic
//    10/90  Brian M Kennedy  Major Rewrite
//    02/90  Brian M Kennedy  Original
//
//***************************************************************************

#include "seq.h"

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Class Definitions

/////////////////////////////////////////////////////////////////////////////
// class lifoQueueA

CLASS_A(lifoQueue, seq)


#define lifoQueue_RETURNING_DEFINITIONS(type)			    	    \
	seq_RETURNING_DEFINITIONS(type)					    \


	lifoQueue_RETURNING_DEFINITIONS(lifoQueue)

   };


/////////////////////////////////////////////////////////////////////////////
// class lifoQueueG

CLASS_G(lifoQueue, seq)

	// Constructors //////////

	    inline
        lifoQueueG (int IsConst = FALSE);

    public:
        // lifoQueue Operations //////////

   };


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Inline Definitions

/////////////////////////////////////////////////////////////////////////////
// lifoQueueG Inlines

// Constructors //////////

    inline lifoQueueG::
lifoQueueG (int IsConst) // IsConst = FALSE)
   :seqG(IsConst)
   {}


/////////////////////////////////////////////////////////////////////////////
// lifoQueueA Inlines

INLINES(lifoQueue, seq)


#define lifoQueue_RETURNING_INLINES(type)				    \
seq_RETURNING_INLINES(type)						    \


lifoQueue_RETURNING_INLINES(lifoQueue)


//***************************************************************************

#endif /* OATH_LIFOQUEUE_H */
