#ifndef OATH_LOCALTOKEN_H

#define OATH_LOCALTOKEN_H

//***************************************************************************
//             OATH :: Tokenect-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991, 1990  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  localToken (localTokenA, localTokenG)
//
//  History:
//    07/91  Brian M Kennedy  Original -- separated from token
//
//***************************************************************************

#include "token.h"

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Class Definitions

/////////////////////////////////////////////////////////////////////////////
// class localTokenA

CLASS_A(localToken, token)

	// Makes //////////

            inline static localTokenA
        make ();


	token_RETURNING_DEFINITIONS(localToken)

   };


/////////////////////////////////////////////////////////////////////////////
// class localTokenG

CLASS_G(localToken, token)

	// Constructors //////////

	    inline
        localTokenG ();

    public:
        // oathCore Operations //////////

            inline virtual int
        isImplementedAs (void* TypeId) const;

	    virtual void
	export (exportP& X) const;

	    static objA
	import (importP& M);

   };


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// Inline Definitions

/////////////////////////////////////////////////////////////////////////////
// localTokenG Inlines

// Constructors //////////

    inline localTokenG::
localTokenG ()
   :tokenG()
   {}

// oathCore Operations //////////

    inline int localTokenG::
isImplementedAs (void* TypeId) const
   {return (TypeId == Type);}


/////////////////////////////////////////////////////////////////////////////
// localTokenA Inlines

INLINES(localToken, token)

// Makes //////////

    inline localTokenA localTokenA::
make ()
   {return new localTokenG();}


token_RETURNING_INLINES(localToken)


//***************************************************************************

#endif /* OATH_LOCALTOKEN_H */
