//***************************************************************************
//             OATH :: Object-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991, 1990  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  obj (objA, objG)
//
//  History:
//    07/91  Brian M Kennedy  import & utility fns: callSelf, callMakeCopy
//    06/91  Brian M Kennedy  New macros & format; remove printDiagnostic
//    10/90  Brian M Kennedy  Major Rewrite
//    02/90  Brian M Kennedy  Original
//
//***************************************************************************

#include "copyright.h"

#include <oath/obj.h>

/////////////////////////////////////////////////////////////////////////////
// obj Outlines

OUTLINES(obj, oathCore)

    objA objG::
import (importP&)
   {ensure(FALSE, "throw: badImportData");
    return objA::Nil;
   }


/////////////////////////////////////////////////////////////////////////////
// Utility functions

    objA
callSelf (objA O)
   {return O.self();}

    objA
callMakeCopy (objA O)
   {return O.makeCopy();}

//***************************************************************************
