//***************************************************************************
//             OATH :: Object-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991, 1990  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  slNodeP
//
//  History:
//    06/91  Brian M Kennedy  New macros & format; remove printDiagnostic
//    10/90  Brian M Kennedy  Major Rewrite
//    02/90  Brian M Kennedy  Original
//
//***************************************************************************

#include "copyright.h"

#include <oath/slNodeP.h>

/////////////////////////////////////////////////////////////////////////////
// slNodeP Outline Definitions

// Dynamic Allocation

#ifdef OATH_HANDLE_NEW

int      slNodeP::AllocateCount = 10;

slNodeP *slNodeP::FreeList      = 0;

    void slNodeP::
allocate ()
   {FreeList = new slNodeP [AllocateCount];
    for(int I = 0; I < AllocateCount-1; I++)
	FreeList[I].Next = &FreeList[I+1];
    FreeList[AllocateCount-1].Next = 0;
   }

#endif

//***************************************************************************
