//***************************************************************************
//             OATH :: Object-oriented Abstract Type Hierarchy
//***************************************************************************
//
//  Copyright (C) 1991, 1990  Texas Instruments Incorporated
//  Permission is granted to any individual or institution
//  to use, copy, modify, and distribute this software,
//  provided that this complete copyright and permission notice
//  is maintained, intact, in all copies and supporting documentation.
//
//  Texas Instruments Incorporated provides this software "as is"
//  without express or implied warranty.
//
//***************************************************************************
//  typeRegisterP (for registration of OATH types)
//
//  History:
//    07/91  Brian M Kennedy  Original
//
//***************************************************************************

#include "copyright.h"

#include <oath/typeRegisterP.h>

#include <iostream.h>

#include <string.h>

/////////////////////////////////////////////////////////////////////////////
// Outlines

typeRegisterP* typeRegisterP::TypeRegistry [OATH_TYPE_REGISTRY_SIZE];

    int typeRegisterP::
hashTypeName (const char* TypeName)
   {int Sum = 0;
    const int Stop = (TypeName[0] < 4 ? TypeName[0] : 4);
    for(int I = 1; I <= Stop; ++I)
        Sum += TypeName[I] - '0'; // assumes '0' is the smallest char value
    assumed(Sum < OATH_TYPE_REGISTRY_SIZE, "Hashing assumptions are invalid!");
    return Sum;			  // that can appear in a type name
   }

    typeRegisterP* typeRegisterP::
findRegister (const char* TypeName)
   {typeRegisterP * TR = TypeRegistry[hashTypeName(TypeName)];
    char Len = TypeName[0];
    while(TR)
       {if(Len == TR->TypeName[0]
	   && (!Len || !memcmp(&TypeName[1], &TR->TypeName[1], Len)))
	    break;
        TR = TR->Next;
       }
    return TR;
   }

    const char* typeRegisterP::
registerType (const char* Name, importF Import)
   {char Len = strlen(Name);
    char* TypeName = new char [Len+1];
    TypeName[0] = Len;
    memcpy(&TypeName[1], Name, Len);
    int Hash = hashTypeName(TypeName);
    TypeRegistry[Hash] = new typeRegisterP (TypeName, Import,
						      TypeRegistry[Hash]);
    return TypeName;
   }

    const char* typeRegisterP::
readType (istream& S)
   {char Len = S.get();
    char* TypeName = new char [Len+1];
    TypeName[0] = Len;
    if(Len)
        S.read(&TypeName[1], Len);
    return TypeName;
   }

    ostream& typeRegisterP::
writeType (ostream& S, const char* TypeName)
   {return S.write(TypeName, TypeName[0]+1);}

//***************************************************************************
